#define PLUGINNAME	"Kick the nades"
#define VERSION 	"0.1"
#define AUTHOR		"JGHG"
/*
Copyleft 2005

Plugin topic: http://www.amxmodx.org/forums/viewtopic.php?p=135972

KICK THE NADES
==============
Look at a close grenade and press use button to kick it away. You can kick smokes, HEs and flashes.
You can only kick one grenade at a time.

You can tweak some stuff through a number of cvars:

kickthenades_radius	Default 75. Increase to be able to kick grenades that are further away. The closest grenade will always be kicked first.
kickthenades_speed	Default 1000. Increase to make nades get a heavier punch.
kickthenades_height	Default -50. Affects the angle of a kicked nade. Decrease to make the nade fly more upwards, increase to make it fly closer to the ground.


VERSIONS
========
059721	0.1	First release.


REQUIRES
========
Engine module, Fakemeta module


TO DO
=====
?


/JGHG
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>

#define CVAR_RADIUS	"kickthenades_radius"
#define CVAR_SPEED	"kickthenades_speed"
#define CVAR_HEIGHT	"kickthenades_height"
#define SOUNDSCOUNT	3
#define PI			3.1415926535897932384626433832795
#define VIEWSPAN	48.0 // degrees, tweakable

new g_MAXPLAYERS
new g_kicksounds[SOUNDSCOUNT][] = {
	"player/bhit_flesh-1.wav",
	"player/bhit_flesh-2.wav",
	"player/bhit_flesh-3.wav"
}
new Float:g_ONEEIGHTYTHROUGHPI

public plugin_precache() {
	precache_sound(g_kicksounds[0])
	precache_sound(g_kicksounds[1])
	precache_sound(g_kicksounds[2])
}

public plugin_modules() {
	require_module("engine")
	require_module("fakemeta")
}

public forward_emitsound(const PIRATE, const Onceuponatimetherewasaverysmall, noise[], const Float:turtlewhoateabiggerturtleand, const Float:afterthatthesmallturtlegot, const veryveryverybig, const theend) {
	// Maybe user pressed the "use" button... if this wave is emitted: common/wpn_denyselect.wav
	// This will not be called when user actually uses something because then common/wpn_select.wav is emitted instead.
	if (PIRATE < 1 || PIRATE > g_MAXPLAYERS || !equal(noise, "common/wpn_denyselect.wav"))
		return FMRES_IGNORED

	//new Float:playerorigin[3]
	//entity_get_vector(PIRATE, EV_VEC_origin, playerorigin)

	//client_print(PIRATE, print_chat, "You pressed use, origin of you: %f %f %f", playerorigin[0], playerorigin[1], playerorigin[2])

	if (client_kicknade(PIRATE)) {
		//client_print(PIRATE, print_center, "You gave the nade a good kick!")
		emit_sound(PIRATE, CHAN_BODY, g_kicksounds[random_num(0, SOUNDSCOUNT - 1)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

		// Block sound.
		return FMRES_SUPERCEDE
	}
	//client_print(PIRATE, print_center, "Ignored!")

	return FMRES_IGNORED
}

bool:client_kicknade(id) {
	// Find nades in vicinity. Kick the nearest one. Later kick the one player is aiming at.
	new grenadeslist[32]
	new grenadesfound = find_sphere_class(id, "grenade", get_cvar_float(CVAR_RADIUS), grenadeslist, 32)
	if (grenadesfound == 0)
		return false

	// Strip out the grenades that aren't hes, smokes and flashes.
	new entlist[32], entsfound = 0, model[64]
	for (new i = 0; i < grenadesfound; i++) {
		entity_get_string(grenadeslist[i], EV_SZ_model, model, 63)
		//server_print("Model of nade: %s", model)
		if (!equal(model, "models/w_hegrenade.mdl") && !equal(model, "models/w_flashbang.mdl") && !equal(model, "models/w_smokegrenade.mdl"))
			continue

		entlist[entsfound++] = grenadeslist[i]
	}
	if (entsfound == 0)
		return false

	// Find the closest one
	new closestindex = 0, Float:closestrange = entity_range(id, entlist[0]), Float:temprange, Float:playerorigin[3]
	for (new i = 1; i < entsfound; i++) {
		temprange = entity_range(id, entlist[i])
		if (temprange < closestrange) {
			closestrange = temprange
			closestindex = i
		}
	}
	entity_get_vector(id, EV_VEC_origin, playerorigin)

	// This is the nade you are looking for.
	new i = entlist[closestindex]

	// Find out if it's in view...
	// TO DO: Trace didn't work... might test with tracing from nade to player later. (yes you can kick through walls if they're thin enough)

	/*if (entity_get_edict(i, EV_ENT_owner) == id) {
		client_print(id, print_chat, "Setting owner to 0!")
		entity_set_edict(i, EV_ENT_owner, 0)
	}

	new Float:targetOrigin[3], Float:hitOrigin[3]
	entity_get_vector(i, EV_VEC_origin, targetOrigin)
	new hitIndex = trace_line(id, playerorigin, targetOrigin, hitOrigin)
	if (hitIndex != i) {
		client_print(id, print_chat, "Trace to nade failed!")
		return false
	}*/

	// Find out if i is within id's scope.
	new Float:hitOrigin[3]
	entity_get_vector(i, EV_VEC_origin, hitOrigin)

	// Get angle to target.
	new Float:x = hitOrigin[0] - playerorigin[0]
	new Float:z = hitOrigin[1] - playerorigin[1]
	new Float:radians = floatatan(z/x, radian) // div by 0? :-P
	new Float:degreeeeees = radians * g_ONEEIGHTYTHROUGHPI
	if (playerorigin[0] > hitOrigin[0]) {
		if (playerorigin[1] < hitOrigin[1])
			degreeeeees += 180.0
		else if (playerorigin[1] > hitOrigin[1])
			degreeeeees -= 180.0
	}
	new Float:viewangles[3]
	entity_get_vector(id, EV_VEC_v_angle, viewangles)

	new Float:difference = viewangles[1] - degreeeeees
	//new bool:visible = false
	if (difference >= -VIEWSPAN && difference <= VIEWSPAN) {
		// It's a yes... it's in view
		//client_print(id, print_chat, "Yes it's in view")
		playerorigin[2] = playerorigin[2] + get_cvar_float(CVAR_HEIGHT) // Hmm.
		set_velocity_from_origin(i, playerorigin, get_cvar_float(CVAR_SPEED))
		return true
	}
	// Not in view. Should really try with next closest nade in entlist, but who cares? Not that often you have many nades near you anyway? To do: Fix this later?
	//client_print(id, print_chat, "No it's not in view")

	return false
}

stock get_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed, Float:fVelocity[3] )
{
    new Float:fEntOrigin[3];
    entity_get_vector( ent, EV_VEC_origin, fEntOrigin );

    // Velocity = Distance / Time

    new Float:fDistance[3];
    fDistance[0] = fEntOrigin[0] - fOrigin[0];
    fDistance[1] = fEntOrigin[1] - fOrigin[1];
    fDistance[2] = fEntOrigin[2] - fOrigin[2];

    new Float:fTime = ( vector_distance( fEntOrigin,fOrigin ) / fSpeed );

    fVelocity[0] = fDistance[0] / fTime;
    fVelocity[1] = fDistance[1] / fTime;
    fVelocity[2] = fDistance[2] / fTime;

    return ( fVelocity[0] && fVelocity[1] && fVelocity[2] );
}


// Sets velocity of an entity (ent) away from origin with speed (speed)

stock set_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed )
{
    new Float:fVelocity[3];
    get_velocity_from_origin( ent, fOrigin, fSpeed, fVelocity )

    entity_set_vector( ent, EV_VEC_velocity, fVelocity );

    return ( 1 );
}


public plugin_init() {
	register_plugin(PLUGINNAME, VERSION, AUTHOR)
	register_forward(FM_EmitSound, "forward_emitsound")
	register_cvar(CVAR_RADIUS, "75")
	register_cvar(CVAR_SPEED, "1000")
	register_cvar(CVAR_HEIGHT, "-50")

	g_MAXPLAYERS = get_maxplayers()
	g_ONEEIGHTYTHROUGHPI = 180.0 / PI
}


