#include <amxmodx>
#include <amxmisc>
#include <nvault>
#include <engine>
#include <hamsandwich>
#include <fakemeta>

new name[33][32];
new ip[33][24];
new bool:ma_mute[33];
new bool:ma_mute_ip[33];
new bool:ma_mute2[33];

new plik_vault;

public plugin_init(){
	register_plugin("Perm Mute", "1.0", "HubertTM");
	plik_vault = nvault_open("PermMute");
	register_clcmd("amx_permmute", "DajMute", 0, "<name>");
	register_clcmd("amx_permmute_menu", "DajMuteMenu");
	register_clcmd("amx_unmute_menu", "DajUnmuteMenu");
	register_clcmd("amx_unpermmute_menu", "DajUnmuteMenu");
	RegisterHam(Ham_Spawn, "player", "Odrodzenie");
	register_forward(FM_Voice_SetClientListening, "Voice_SetClientListening");
	register_clcmd("amx_mute2", "DajMute2", 0, "<name>");
	register_clcmd("amx_mute2menu", "DajMuteMenu2", 0, "<name>");
	register_clcmd("amx_mute2_menu", "DajMuteMenu2", 0, "<name>");
}


public plugin_end()
	nvault_close(plik_vault);


public client_putinserver(id){
	ma_mute2[id] = false;
	ma_mute[id] = false;
	ma_mute_ip[id] = false;
	name[id] = "";
	ip[id] = "";

	if(is_user_connected(id)){
	get_user_name(id, name[id], 31);
	get_user_ip(id, ip[id], 23);
	wczytaj_mute(id);
	
	if(ma_mute[id] || ma_mute_ip[id]){
		set_speak(id, SPEAK_MUTED)
		}
	}
}
public client_disconnect(id){
	zapisz_mute(id)
	
	ma_mute2[id] = false;
	ma_mute[id] = false;
	ma_mute_ip[id] = false;
	name[id] = "";
	ip[id] = "";
}

public Odrodzenie(id){
	if(is_user_alive(id) && (ma_mute[id] || ma_mute_ip[id]))
	{
		set_speak(id, SPEAK_MUTED)
		client_cmd(id, "-voicerecord");
	}
}

public DajMuteMenu(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
		return PLUGIN_HANDLED;
	
	
	new menu = menu_create("Kogo zmutowac \r[NA ZAWSZE]?", "DajMuteMenuH");
	for(new i=1; i<33; i++){
		if(is_user_connected(i) && !ma_mute[i] && !ma_mute_ip[id] && !(get_user_flags(i) & read_flags("a")))	
			menu_additem(menu, name[i]);
	}
	menu_display(id, menu);
	
	
	return PLUGIN_HANDLED
}

public DajMuteMenuH(id, menu, item){
	if(item == MENU_EXIT)
		return PLUGIN_HANDLED;
	
	if(!is_user_connected(id))
		return PLUGIN_HANDLED;
	
	new acces, info[6], name2[32], callback;
	
	menu_item_getinfo(menu, item, acces, info, 5, name2, 31, callback);
	
	new player = cmd_target(id, name2, CMDTARGET_ALLOW_SELF)
	
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Gracz ^"%s^" nie zostal odnaleziony.",name2);
		return PLUGIN_HANDLED;
	}
	else
	{
		client_print(id, print_chat,"ZMUTOWANO!");
		client_print(id, print_console,"ZMUTOWANO!");
		ma_mute[player] = true;
		ma_mute_ip[player] = true;
		set_speak(player, SPEAK_MUTED)
		client_cmd(player, "-voicerecord");
		client_print(player,print_chat,"*** Zostales wyciszony na zawsze [MOZESZ SIE ODWOLAC NA FORUM!] ***");
	}
	return PLUGIN_HANDLED;
}


public DajMuteMenu2(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
		return PLUGIN_HANDLED;
	
	
	new menu = menu_create("Kogo zmutowac \r[NA MAPE] ?", "DajMuteMenuH2");
	for(new i=1; i<33; i++){
		if(is_user_connected(i) && !ma_mute_ip[i] && !ma_mute2[i] && !ma_mute[i] && !(get_user_flags(i) & read_flags("a")))	
			menu_additem(menu, name[i]);
	}
	menu_display(id, menu);
	
	
	return PLUGIN_HANDLED
}

public DajMuteMenuH2(id, menu, item){
	if(item == MENU_EXIT)
		return PLUGIN_HANDLED;
	
	if(!is_user_connected(id))
		return PLUGIN_HANDLED;
	
	new acces, info[6], name2[32], callback;
	
	menu_item_getinfo(menu, item, acces, info, 5, name2, 31, callback);
	
	new player = cmd_target(id, name2, CMDTARGET_ALLOW_SELF)
	
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Gracz ^"%s^" nie zostal odnaleziony.",name2);
		return PLUGIN_HANDLED;
	}
	else
	{
		client_print(id, print_chat,"ZMUTOWANO!");
		client_print(id, print_console,"ZMUTOWANO!");
		ma_mute2[player] = true;
		set_speak(player, SPEAK_MUTED)
		client_cmd(player, "-voicerecord");
		client_print(player,print_chat,"*** Zostales wyciszony! Uwazaj, bo mozesz dostac PERNAMENTENGO muta! ***");
	}
	return PLUGIN_HANDLED;
}


public DajUnmuteMenu(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
		return PLUGIN_HANDLED;
	
	
	new menu = menu_create("Kogo odmutowac?", "DajUnmuteMenuH");
	for(new i=1; i<33; i++){
		if(is_user_connected(i) && (ma_mute[i] || ma_mute_ip[i] || ma_mute2[i]))	
			menu_additem(menu, name[i]);
	}
	menu_display(id, menu);
	
	
	return PLUGIN_HANDLED
}

public DajUnmuteMenuH(id, menu, item){
	if(item == MENU_EXIT)
		return PLUGIN_HANDLED;
	
	if(!is_user_connected(id))
		return PLUGIN_HANDLED;
	
	new acces, info[6], name2[32], callback;
	
	menu_item_getinfo(menu, item, acces, info, 5, name2, 31, callback);
	
	new player = cmd_target(id, name2, CMDTARGET_ALLOW_SELF)
	
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Gracz %s nie zostal odnaleziony.",name2);
		return PLUGIN_HANDLED;
	}
	else
	{
		client_print(id, print_chat,"ODMUTOWANO!");
		client_print(id, print_console,"ODMUTOWANO!");
	
		zapisz_mute2(player);
		ma_mute_ip[player] = false;
		ma_mute[player] = false;
		ma_mute2[player] = false;
		set_speak(player, SPEAK_NORMAL)
		client_print(player,print_chat,"*** Zostales odmutowany ***");
	}
	return PLUGIN_HANDLED;
}



public DajMute(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
		return PLUGIN_HANDLED;
	
	new arg1[32];
	read_argv(1, arg1, 31)
	
	new player=cmd_target(id, arg1, CMDTARGET_ALLOW_SELF)
	
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Gracz %s nie zostal odnaleziony.",arg1);
		return PLUGIN_HANDLED;
	}
	else
	{
		ma_mute[player] = true;
		ma_mute_ip[player] = true;
		set_speak(player, SPEAK_MUTED)
		client_print(id, print_chat,"ZMUTOWANO!");
		client_print(id, print_console,"ZMUTOWANO!");
		client_print(player, print_chat,"*** Zostales wyciszony na zawsze [MOZESZ ODWOLAC SIE NA FORUM!] ***");
	}
	
	return PLUGIN_HANDLED
}

public DajMute2(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
		return PLUGIN_HANDLED;
	
	new arg1[32];
	read_argv(1, arg1, 31)
	
	new player=cmd_target(id, arg1, CMDTARGET_ALLOW_SELF)
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Gracz %s nie zostal odnaleziony.",arg1);
		return PLUGIN_HANDLED;
	}
	else
	{
		ma_mute2[player] = true;
		set_speak(player, SPEAK_MUTED)
		client_print(id, print_chat,"ZMUTOWANO!");
		client_print(id, print_console,"ZMUTOWANO!");
		client_print(player, print_chat,"*** Zostales wyciszony! Uwazaj, bo mozesz jeszcze dostac PERNAMENTEGO muta! ***");
	}
	
	return PLUGIN_HANDLED
}


public wczytaj_mute(id)
{
	new vaultkey[64],vaultdata[256]
	format(vaultkey,63,"%s-m-",name[id])
	format(vaultdata,255,"%d",ma_mute[id])
	nvault_get(plik_vault,vaultkey,vaultdata,255) 
	
	new wartosc[6];
	parse(vaultdata,wartosc, 5) 
	
	if(str_to_num(wartosc))
		ma_mute[id] = true; 
		
	format(vaultkey,63,"%s-mip-",ip[id]) 
	format(vaultdata,255,"%d", ma_mute_ip[id]) 
	nvault_get(plik_vault,vaultkey,vaultdata,255) 
	
	new wartosc2[6];
	parse(vaultdata, wartosc2, 5) 
	
	if(str_to_num(wartosc2))
		ma_mute_ip[id] = true; 
}  



public zapisz_mute(id){
	new vaultkey[64],vaultdata[256] 
	if(ma_mute[id]){	
		format(vaultkey,63,"%s-m-",name[id]) 
		format(vaultdata,255,"1") 
		nvault_set(plik_vault,vaultkey,vaultdata) 
	}
	if(ma_mute_ip[id]){
		format(vaultkey,63,"%s-mip-",ip[id]) 
		format(vaultdata,255,"1") 
		nvault_set(plik_vault,vaultkey,vaultdata) 
	}
}

public zapisz_mute2(id){
	new vaultkey[64],vaultdata[256] 
	format(vaultkey,63,"%s-m-",name[id]) 
	format(vaultdata,255,"0") 
	nvault_set(plik_vault,vaultkey,vaultdata) 
	
	format(vaultkey,63,"%s-mip-",ip[id]) 
	format(vaultdata,255,"0") 
	nvault_set(plik_vault,vaultkey,vaultdata) 
}

public Voice_SetClientListening(odbiorca, nadawca, listen) 
{
	if(odbiorca == nadawca)
		return FMRES_IGNORED;
	
	if(ma_mute[nadawca] || ma_mute_ip[nadawca] || ma_mute2[nadawca])
	{
		engfunc(EngFunc_SetClientListening, odbiorca, nadawca, false);
		return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED;
}