#include < amxmodx >
#include < amxmisc >
#include < cstrike >
#include < fakemeta >
#include < hamsandwich >
#include < cs_player_models_api >

new const PLUGIN_VERSION[ ] = "1.0";
new const FILE_NAME[ ] = "model_extend.ini";
new const REGEX_DIR[ ] = "model_api";
new const STANDARD_FILL[ ] = "^"gign^" ^"newmodel^"";
new const MODEL_DIR[ ] = "models/player";

new PATH_FILE[ 64 ];
new REGEX_FILE_DIR[ 64 ];
new FULL_DIR[ 64 ];

new g_player_model[ 33 ][ 33 ];
new szOldModels[ 9 ][ 33 ];
new szNewModels[ 9 ][ 33 ];

new bool:has_custom_model[ 33 ] = { false };

public plugin_precache( ) {
	get_configsdir( PATH_FILE, charsmax( PATH_FILE ) );
	
	formatex( FULL_DIR, charsmax( FULL_DIR ), "%s/%s/%s", PATH_FILE, REGEX_DIR, FILE_NAME );
	formatex( REGEX_FILE_DIR, charsmax( REGEX_FILE_DIR ), "%s/%s", PATH_FILE, REGEX_DIR );
	
	if( dir_exists( REGEX_FILE_DIR ) != 1 )
	{
		mkdir( REGEX_FILE_DIR );
	}
	
	if( file_exists( FULL_DIR ) != 1 )
	{
		write_file( FULL_DIR, STANDARD_FILL, -1 );
	}
	
	new Text[ 255 ], Buffer[ 2 ][ 32 ], iLineLen;
	for( new i = 0; read_file( FULL_DIR, i, Text, charsmax( Text ), iLineLen ); i++ ) {
		if( ( Text[ 0 ] == ';' ) || !iLineLen ) continue;
		
		parse( Text, Buffer[ 0 ], 31, Buffer[ 1 ], 31 );
		
		replace_all( Buffer[ 0 ], 31, "^"", "" );
		replace_all( Buffer[ 1 ], 31, "^"", "" );
		
		szOldModels[ i ] = Buffer[ 0 ];
		szNewModels[ i ] = Buffer[ 1 ];
		
		format( Buffer[ 1 ], 31, "%s/%s/%s.mdl", MODEL_DIR, Buffer[ 1 ], Buffer[ 1 ] );
		
		precache_model( Buffer[ 1 ] );
	}
	
}

public plugin_init( ) {
	register_plugin( "Player Models Extended Api", PLUGIN_VERSION, "Ortega" );
	
	register_message( get_user_msgid( "ClCorpse" ), "message_ClCorpse" );
	register_message( get_user_msgid( "TeamInfo" ), "message_TeamInfo" );
	
	RegisterHam( Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1 );
	
	register_forward( FM_SetClientKeyValue, "fw_SetClientKeyValue" );
	register_forward( FM_ClientDisconnect, "fw_ClientDisconnect" );
	
}

public message_ClCorpse( ) {
	static id;
	id = get_msg_arg_int( 12 );
	
	if( has_custom_model[ id ] )
		set_msg_arg_string( 1, g_player_model[ id ] );
	
}

public message_TeamInfo( msg_id, msg_dest ) {
	if( msg_dest != MSG_ALL && msg_dest != MSG_BROADCAST )
		return;
	
	static id;
	id = get_msg_arg_int( 1 );
	
	has_custom_model[ id ] = false;
	
}

public fw_PlayerSpawn_Post( id ) {   
	if( !is_user_alive( id ) || !cs_get_user_team( id ) )
		return;
	
	if( !has_custom_model[ id ] )
	{
		new currentmodel[ 32 ];
		cs_get_user_model( id, currentmodel, charsmax( currentmodel ) );
		new cell = model_to_cell( currentmodel );
		
		SetProperModel( id, currentmodel, cell );
	}
	
}

public fw_ClientDisconnect( id )
	has_custom_model[ id ] = false;

public fw_SetClientKeyValue( id, const infobuffer[ ], const key[ ] ) {
	if( has_custom_model[ id ] && equal( key, "model" ) )
	{
		static currentmodel[ 32 ];
		cs_get_user_model( id, currentmodel, charsmax( currentmodel ) );
		new cell = model_to_cell( currentmodel );
		
		for( new i = 0; i < sizeof( szOldModels ); i ++ )
		{
			if( equal( currentmodel, szOldModels[ i ] ) )
			{
				has_custom_model[ id ] = false;
				SetProperModel( id, currentmodel, cell );
				break;
			}
		}
		return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED;
}

public SetProperModel( index, const oldmodel[ ], cell ) {
	new ents = global_get( glb_maxEntities );
	new szPevModel[ 32 ];
	for( new i = 1; i < ents; i++ )
	{
		pev( i, pev_model, szPevModel, 31 );
		if( equal( oldmodel, szPevModel ) )
		{
			cs_set_player_model( i, szNewModels[ cell ] );
			has_custom_model[ i ] = true;
			g_player_model[ i ] = szNewModels[ cell ];
		}
	}
	
}

public model_to_cell( model[ ] ) {
	new cell;
	for( new i = 0; i < sizeof( szOldModels ); i ++ )
	{
		if( equal( model, szOldModels[ i ] ) )
		{
			cell = i;
			break;
		}
	}
	return ( cell );
}
